      SUBROUTINE  INSERT (HEAD,INDEX)
C     INSERT THE SYMBOL AT ENTRY 'INDEX' IN DSA(*) INTO THE LINKED
C     LIST POINTED TO BY DSA(HEAD+2), MAINTAINING PFORT LEXICAL
C     ORDER.
      INTEGER HEAD, INDEX, LEXORD, LOOK, LAST, K
      INTEGER LDSA, PDSA, DSA
      COMMON /CTABL/ LDSA, PDSA, DSA(5000)
      INTEGER NEXT, LAB, SYM, BNEXT
      COMMON /TABL / NEXT, LAB, SYM, BNEXT
      LOGICAL ERR, SYSERR, ABORT
      COMMON /DETECT/ ERR, SYSERR, ABORT
      LOOK = DSA(HEAD+2)
      LAST = HEAD + 1
C
C     SEARCH LIST FOR PLACE TO INSERT SYMBOL.
C
   10 IF (LOOK .LE. 0) GO TO 40
      K = DSA(LOOK)
      IF (LEXORD(INDEX,K)) 20,50,30
C
C     SYMBOL(INDEX) .LT. SYMBOL(K) - INSERT SYMBOL INTO CHAIN BEFORE
C     POSITION 'LOOK'.
C
   20 IF ((NEXT+2) .GE. BNEXT) GO TO 60
      DSA(NEXT) = INDEX
      DSA(NEXT+1) = LOOK
      DSA(LAST+1) = NEXT
      NEXT = NEXT + 2
      GO TO 50
C
C     SYMBOL(INDEX) .GT. SYMBOL(K) - CONTINUE SEARCH
C
   30 LAST = LOOK
      LOOK = DSA(LOOK+1)
      GO TO 10
C
C     INSERT INDEX AT END OF LIST.
C
   40 IF ((NEXT+2) .GE. BNEXT) GO TO 60
      DSA(LAST+1) = NEXT
      DSA(NEXT) = INDEX
      DSA(NEXT+1) = 0
      NEXT = NEXT + 2
   50 RETURN
C
C     ERROR SECTION.
C
   60 CALL ERROR1 (33H IN INSERT, TABLE OVERFLOW OF DSA,33)
      SYSERR = .TRUE.
      GO TO 50
      END
